registerInputEvent(fxDTSBrick, "onFirstActivate", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame Minigame");

package onFirstActivate
{
	function Player::activateStuff(%this)
	{
		parent::activateStuff(%this);
		%this.onFirstActivateStuff();
	}
};
activatePackage(onFirstActivate);

function Player::onFirstActivateStuff(%this)
{
	%client = %this.client;
	
	%EyeVector = %this.getEyeVector();
	%EyePoint = %this.getEyePoint();
	
	%Range = 6;
	%RangeScale = VectorScale(%EyeVector, %Range);
	%RangeEnd = VectorAdd(%EyePoint, %RangeScale);
	
	%raycast = containerRayCast(%eyePoint, %RangeEnd, $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::FxBrickObjectType, %this);

	if(isObject(%rayCast))
	{
		%brick = %raycast;
  		$InputTarget_["Self"]   = %brick;
  		$InputTarget_["Player"] = %client.player;
   		$InputTarget_["Client"] = %client;
     	if(getMiniGameFromObject(%brick) == getMiniGameFromObject(%client))
		{
        	$InputTarget_["MiniGame"] = getMiniGameFromObject(%brick);
		}
      	else
		{
        	$InputTarget_["MiniGame"] = 0;
		}
		
		%brickID = getWord(%brick, 0);
		
		if(!%this.hasActivatedBrick[%brickID])
		{
			%brick.processInputEvent("onFirstActivate",%client);
			%this.hasActivatedBrick[%brickID] = true;
		}
		
		else
		{
			return;
		}
	}
}