//+=========================================================================================================+\\
//|			Made by..																						|\\
//|		   ____   ____  _                __          _                   									|\\
//|		  |_  _| |_  _|(_)              [  |        / |_                 									|\\
//| 		\ \   / /  __   .--.   .--.  | |  ,--. `| |-' .--.   _ .--.  									|\\
//| 		 \ \ / /  [  | ( (`\]/ .'`\ \| | `'_\ : | | / .'`\ \[ `/'`\] 									|\\
//| 		  \ ' /    | |  `'.'.| \__. || | // | |,| |,| \__. | | |     									|\\
//|    		   \_/    [___][\__) )'.__.'[___]\'-;__/\__/ '.__.' [___]    									|\\
//|								BL_ID: 20490																|\\
//|				Forum Profile: http://forum.blockland.us/index.php?action=profile;u=40877;					|\\
//|																											|\\
//|		Random Item Event																					|\\
//|			Item events, can go up to 4 items restricting to be picked.										|\\
//+=========================================================================================================+\\

registerInputEvent(fxDtsBrick,"onRelay","Self fxDtsBrick" TAB "Player Player" TAB "Bot Bot" TAB "Client GameConnection" TAB "Minigame Minigame");

package onRelay
{
	function fxDTSBrick::onRelay(%obj, %client) 
	{
		%mini = getMinigameFromObject(%client);
		$InputTarget_["Self"]   = %obj;
		$InputTarget_["Player"] = %client.player;
		$InputTarget_["Bot"] = %obj.hBot;
		$inputTarget_["Client"] = %client;
		$inputTarget_["Minigame"] = %mini;
		%obj.processInputEvent("OnRelay", %client);
	}
};
activatepackage(onRelay);

function isActivePackage(%package)
{
	if(!isPackage(%package))
		return false;
	%count = getNumActivePackages();

	for(%i=0;%i<%count;%i++)
	{
		if(getActivePackage(%i) $= %package)
			return true;
	}
	return false;
}

function serverCmdToggleRelay(%this)
{
	if(%this.getBLID() != getNumKeyID())
		return;
	if(!isActivePackage(onRelay))
	{
		%msg = "\c0UNRESTRICTED";
		activatepackage(onRelay);
	}
	else
	{
		%msg = "\c2RESTRICTED";
		deactivatepackage(onRelay);
	}
	messageAll('',"\c6Input: \c4onRelay \c6is now " @ %msg);
}