registerInputEvent("fxDTSBrick", "onBotTargetLoop", "Self fxDTSBrick" TAB "Bot Bot" TAB "Target_Player Player" TAB "Target_Bot Bot" TAB "Target_Client GameConnection" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick", "onBotNewTarget", "Self fxDTSBrick" TAB "Bot Bot" TAB "Target_Player Player" TAB "Target_Bot Bot" TAB "Target_Client GameConnection" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick", "onBotLoseTarget", "Self fxDTSBrick" TAB "Bot Bot" TAB "Target_Player Player" TAB "Target_Bot Bot" TAB "Target_Client GameConnection" TAB "Client GameConnection" TAB "MiniGame MiniGame");

package Event_BotTarget
{
	function AIPlayer::hLoop(%this)
	{
		%parent = Parent::hLoop(%this); //Don't remember if I'm supposed to return the parent, I'll just do it anyways.
		if(isEventPending(%this.hSched) && %this.hLoopActive && isObject(%brick = %this.spawnBrick))
		{
			%client = %brick.brickgroup.client;
			%targ = %this.hFollowing;
			%lastTarg = %this.hLastTarget;

			if(%targ != %this.hLastTarget && isObject(%targ) && %this.getState() !$= "dead") //Changing targets, or getting a new target in general
			{
				$InputTarget_["Self"]   = %brick;
				$InputTarget_["Bot"] = %this;
				$InputTarget_["Target_Player"] = %lastTarg;
				$InputTarget_["Target_Bot"] = %lastTarg;
				$InputTarget_["Target_Client"] = %lastTarg.client;
				$InputTarget_["Client"] = %client;
				$InputTarget_["MiniGame"] = getMiniGameFromObject(%brick);
				%brick.processInputEvent("onBotLoseTarget", %client);

				$InputTarget_["Self"]   = %brick;
				$InputTarget_["Bot"] = %this;
				$InputTarget_["Target_Player"] = %targ;
				$InputTarget_["Target_Bot"] = %targ;
				$InputTarget_["Target_Client"] = %targ.client;
				$InputTarget_["Client"] = %client;
				$InputTarget_["MiniGame"] = getMiniGameFromObject(%brick);
				%brick.processInputEvent("onBotNewTarget", %client);
			}
			else if(%targ != %this.hLastTarget && !isObject(%targ)) //Lost the target
			{
				$InputTarget_["Self"]   = %brick;
				$InputTarget_["Bot"] = %this;
				$InputTarget_["Target_Player"] = %lastTarg;
				$InputTarget_["Target_Bot"] = %lastTarg;
				$InputTarget_["Target_Client"] = %lastTarg.client;
				$InputTarget_["Client"] = %client;
				$InputTarget_["MiniGame"] = getMiniGameFromObject(%brick);
				%brick.processInputEvent("onBotLoseTarget", %client);
			}
			else if(isObject(%targ)) //Target loop
			{
				$InputTarget_["Self"]   = %brick;
				$InputTarget_["Bot"] = %this;
				$InputTarget_["Target_Player"] = %targ;
				$InputTarget_["Target_Bot"] = %targ;
				$InputTarget_["Target_Client"] = %targ.client;
				$InputTarget_["Client"] = %client;
				$InputTarget_["MiniGame"] = getMiniGameFromObject(%brick);
				%brick.processInputEvent("onBotTargetLoop", %client);
			}

			%this.hLastTarget = %targ;
		}

		return %parent;
	}
};
activatePackage("Event_BotTarget");