datablock ItemData(SeagullDisplayItem : HammerItem)
{
	shapeFile = "./seagull.dts";
	uiName = "Crow";

	isProp = 1;
	passiveThread = "flight";
	image = "";
	doColorShift = false;
};

package SeagullItemPackage
{
	function ItemData::onAdd(%this, %obj)
	{
		%ret = parent::onAdd(%this, %obj);

		if (%obj.getDatablock().isProp)
		{
			%obj.canPickup = false;
		}
		if (%obj.getDatablock().passiveThread !$= "")
		{
			%obj.schedule(getRandom() * 1000, playThread, 0, %obj.getDatablock().passiveThread);
		}

		return %ret;
	}
};
activatePackage(SeagullItemPackage);