//preferences
if($Pref::Server::SmallRampsPlus::Crests $= "")   $Pref::Server::SmallRampsPlus::Crests = true;
if($Pref::Server::SmallRampsPlus::CrestCorners $= "")   $Pref::Server::SmallRampsPlus::CrestCorners = true;

if($Pref::Server::SmallRampsPlus::Tetrahedrons $= "")   $Pref::Server::SmallRampsPlus::Tetrahedrons = true;
if($Pref::Server::SmallRampsPlus::sTetrahedrons $= "")   $Pref::Server::SmallRampsPlus::sTetrahedrons = true;

if($Pref::Server::SmallRampsPlus::LongerRamps $= "")   $Pref::Server::SmallRampsPlus::LongerRamps = true;
if($Pref::Server::SmallRampsPlus::BiggerRamps $= "")   $Pref::Server::SmallRampsPlus::BiggerRamps = true;
// if($Pref::Server::SmallRampsPlus::Cutouts $= "")   $Pref::Server::SmallRampsPlus::Cutouts = true;

if($RTB::Hooks::ServerControl)
{
	RTB_registerPref("Enable Crests", "Small Ramps + | Crests", "$Pref::Server::SmallRampsPlus::Crests",	"bool",	"Brick_SmallRampsPlus", true, true, false, false);
	RTB_registerPref("Enable Crest Corners [Requires crests]", "Small Ramps + | Crests", "$Pref::Server::SmallRampsPlus::CrestCorners",	"bool",	"Brick_SmallRampsPlus", true, true, false, false);
	
	RTB_registerPref("Enable Tetrahedrons", "Small Ramps + | Tetrahedrons", "$Pref::Server::SmallRampsPlus::Tetrahedrons",	"bool",	"Brick_SmallRampsPlus", true, true, false, false);
	RTB_registerPref("Enable Side Tetrahedrons", "Small Ramps + | Tetrahedrons", "$Pref::Server::SmallRampsPlus::sTetrahedrons",	"bool",	"Brick_SmallRampsPlus", true, true, false, false);
	
	RTB_registerPref("Enable Longer Ramps", "Small Ramps + | General", "$Pref::Server::SmallRampsPlus::LongerRamps",	"bool",	"Brick_SmallRampsPlus", true, true, false, false);
	RTB_registerPref("Enable Bigger Ramps", "Small Ramps + | General", "$Pref::Server::SmallRampsPlus::BiggerRamps",	"bool",	"Brick_SmallRampsPlus", true, true, false, false);
	// RTB_registerPref("Enable Cut-outs", "Small Ramps + | General", "$Pref::Server::SmallRampsPlus::Cutouts",	"bool",	"Brick_SmallRampsPlus", true, true, false, false);
}
	
//Execution

exec("./Symmetry.cs");

if($Pref::Server::SmallRampsPlus::Crests)
{
	exec("./crests.cs");
	if($Pref::Server::SmallRampsPlus::LongerRamps)
		exec("./crests16x.cs");
	if($Pref::Server::SmallRampsPlus::CrestCorners)
	exec("./crestcorners.cs");
}
 
if($Pref::Server::SmallRampsPlus::LongerRamps)
{
	exec("./longerramps.cs");
}

if($Pref::Server::SmallRampsPlus::BiggerRamps)
{
	exec("./biggerramps.cs");
}

if($Pref::Server::SmallRampsPlus::Tetrahedrons)
{
	exec("./tetrahedrons.cs");
	if($Pref::Server::SmallRampsPlus::Tetrahedrons)
		exec("./sidetetrahedrons.cs");			
}