%error = ForceRequiredAddOn( "Support_Doors" );
if( %error == $Error::AddOn_NotFound )
{
	error("Brick Doors: Support_Doors is missing somehow, what did you do?");
}

datablock fxDTSBrickData(brickPipeValveUpData)
{
	brickFile = "./valve_open.blb";
	uiName = "Pipe Valve";
	iconName = "Add-Ons/Brick_Pipes/PipeValveIcon";

	isDoor = 1;
	isOpen = 1;

	closedCW = "brickPipeValveDownData";
	openCW = "brickPipeValveUpData";

	closedCCW = "brickPipeValveDownData";
	openCCW = "brickPipeValveUpData";
};


datablock fxDTSBrickData(brickPipeValveDownData : brickPipeValveUpData)
{
	brickFile = "./valve_closed.blb";
	
	isOpen = 0;

	category = "Special";
	subCategory = "Pipes";
};

datablock fxDTSBrickData(brickPipeSprinklerLeftData)
{
	brickFile = "./sprinkler_lr.blb";
	uiName = "Sprinkler";
	iconName = "Add-Ons/Brick_Pipes/SprinklerIcon";

	isDoor = 1;
	isOpen = 1;

	closedCW = "brickPipeSprinklerRightData";
	openCW = "brickPipeSprinklerLeftData";

	closedCCW = "brickPipeSprinklerRightData";
	openCCW = "brickPipeSprinklerLeftData";
};


datablock fxDTSBrickData(brickPipeSprinklerRightData : brickPipeSprinklerLeftData)
{
	brickFile = "./sprinkler_rl.blb";
	
	isOpen = 0;

	category = "Special";
	subCategory = "Pipes";
};

datablock fxDTSBrickData(brickPipe1xData)
{
	brickFile = "./pipe_1x.blb";
	uiName = "Pipe 1x";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/Pipex1Icon";
};

datablock fxDTSBrickData(brickPipe1xIndicatorData)
{
	brickFile = "./pipe_1xindicator.blb";
	uiName = "Pipe Indicator";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/IndicatorIcon";
};

datablock fxDTSBrickData(brickPipeEndData)
{
	brickFile = "./pipe_End.blb";
	uiName = "Pipe End";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/PipeEndIcon";
};

datablock fxDTSBrickData(brickPipe2xData)
{
	brickFile = "./pipe_2x.blb";
	uiName = "Pipe 2x";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/Pipex2Icon";
};

datablock fxDTSBrickData(brickPipe8xData)
{
	brickFile = "./pipe_8x.blb";
	uiName = "Pipe 8x";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/Pipex8Icon";
};

datablock fxDTSBrickData(brickPipeTurnData)
{
	brickFile = "./pipe_Turn.blb";
	uiName = "Pipe Elbow";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/PipeElbowIcon";
};


datablock fxDTSBrickData(brickPipeTData)
{
	brickFile = "./pipe_t.blb";
	uiName = "Pipe T";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/PipeTIcon";
};

datablock fxDTSBrickData(brickPipeCrossData)
{
	brickFile = "./pipe_plus.blb";
	uiName = "Pipe Cross";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/PipeCrossIcon";
};

datablock fxDTSBrickData(brickPumpData)
{
	brickFile = "./pump.blb";
	uiName = "Pump";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/PumpIcon";
};

datablock fxDTSBrickData(brickFeederData)
{
	brickFile = "./feeder.blb";
	uiName = "Feeder";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/FeederIcon";
};

datablock fxDTSBrickData(brickPipe1xVertData)
{
	brickFile = "./pipe_1xVert.blb";
	uiName = "Pipe 1x Vert";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/Pipe1xVertIcon";
};

datablock fxDTSBrickData(brickPipe2xVertData)
{
	brickFile = "./pipe_2xVert.blb";
	uiName = "Pipe 2x Vert";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/Pipe2xVertIcon";
};

datablock fxDTSBrickData(brickPipe5xVertData)
{
	brickFile = "./pipe_5xVert.blb";
	uiName = "Pipe 5x Vert";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/Pipe5xVertIcon";
};

datablock fxDTSBrickData(brickPipeTUpData)
{
	brickFile = "./pipe_tup.blb";
	uiName = "Pipe T Up";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/PipeTUpIcon";
};

datablock fxDTSBrickData(brickPipeTDownData)
{
	brickFile = "./pipe_tDown.blb";
	uiName = "Pipe T Down";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/PipeTDownIcon";
};

datablock fxDTSBrickData(brickPipeTurnDownData)
{
	brickFile = "./pipe_elbowDown.blb";
	uiName = "Pipe Elbow Down";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/PipeElbowDownIcon";
};

datablock fxDTSBrickData(brickPipeTurnUpData)
{
	brickFile = "./pipe_elbowUp.blb";
	uiName = "Pipe Elbow Up";

	category = "Special";
	subCategory = "Pipes";
	iconName = "Add-Ons/Brick_Pipes/PipeElbowUpIcon";
};


//inverted and side valves/sprinklers

datablock fxDTSBrickData(brickPipeValveUpInvertedData)
{
	brickFile = "./valve_invertedopen.blb";
	uiName = "Pipe Valve Inverted";
	iconName = "Add-Ons/Brick_Pipes/PipeValveInvertedIcon";

	isDoor = 1;
	isOpen = 1;

	closedCW = "brickPipeValveDownInvertedData";
	openCW = "brickPipeValveUpInvertedData";

	closedCCW = "brickPipeValveDownInvertedData";
	openCCW = "brickPipeValveUpInvertedData";
};


datablock fxDTSBrickData(brickPipeValveDownInvertedData : brickPipeValveUpInvertedData)
{
	brickFile = "./valve_invertedclosed.blb";
	
	isOpen = 0;

	category = "Special";
	subCategory = "Pipes";
};

datablock fxDTSBrickData(brickPipeSprinklerLeftInvertedData)
{
	brickFile = "./sprinkler_lrinverted.blb";
	uiName = "Sprinkler Inverted";
	iconName = "Add-Ons/Brick_Pipes/SprinklerInvertedIcon";

	isDoor = 1;
	isOpen = 1;

	closedCW = "brickPipeSprinklerRightInvertedData";
	openCW = "brickPipeSprinklerLeftInvertedData";

	closedCCW = "brickPipeSprinklerRightInvertedData";
	openCCW = "brickPipeSprinklerLeftInvertedData";
};


datablock fxDTSBrickData(brickPipeSprinklerRightInvertedData : brickPipeSprinklerLeftInvertedData)
{
	brickFile = "./sprinkler_rlinverted.blb";
	
	isOpen = 0;

	category = "Special";
	subCategory = "Pipes";
};

datablock fxDTSBrickData(brickPipeValveUpSideData)
{
	brickFile = "./valve_Sideopen.blb";
	uiName = "Pipe Valve Side";
	iconName = "Add-Ons/Brick_Pipes/PipeValveSideIcon";

	isDoor = 1;
	isOpen = 1;

	closedCW = "brickPipeValveDownSideData";
	openCW = "brickPipeValveUpSideData";

	closedCCW = "brickPipeValveDownSideData";
	openCCW = "brickPipeValveUpSideData";
};


datablock fxDTSBrickData(brickPipeValveDownSideData : brickPipeValveUpSideData)
{
	brickFile = "./valve_Sideclosed.blb";
	
	isOpen = 0;

	category = "Special";
	subCategory = "Pipes";
};

datablock fxDTSBrickData(brickPipeSprinklerLeftSideData)
{
	brickFile = "./sprinkler_udSide.blb";
	uiName = "Sprinkler Side";
	iconName = "Add-Ons/Brick_Pipes/SprinklerSideIcon";

	isDoor = 1;
	isOpen = 1;

	closedCW = "brickPipeSprinklerRightSideData";
	openCW = "brickPipeSprinklerLeftSideData";

	closedCCW = "brickPipeSprinklerRightSideData";
	openCCW = "brickPipeSprinklerLeftSideData";
};


datablock fxDTSBrickData(brickPipeSprinklerRightSideData : brickPipeSprinklerLeftSideData)
{
	brickFile = "./sprinkler_duSide.blb";
	
	isOpen = 0;

	category = "Special";
	subCategory = "Pipes";
};