//+=========================================================================================================+\\
//|			Made by..																						|\\
//|        ____   ____  _                __          _                                                      |\\
//|       |_  _| |_  _|(_)              [  |        / |_                                                    |\\
//|         \ \   / /  __   .--.   .--.  | |  ,--. `| |-' .--.   _ .--.                                     |\\
//|          \ \ / /  [  | ( (`\]/ .'`\ \| | `'_\ : | | / .'`\ \[ `/'`\]                                    |\\
//|           \ ' /    | |  `'.'.| \__. || | // | |,| |,| \__. | | |                                        |\\
//|            \_/    [___][\__) )'.__.'[___]\'-;__/\__/ '.__.' [___]                                       |\\
//|                             BL_ID: 20490                                                                |\\
//|				Forum Profile: http://forum.blockland.us/index.php?action=profile;u=40877;                  |\\
//|																											|\\
//+=========================================================================================================+\\

package Event_onBotDamageStuffs
{
	function Armor::damage(%this,%obj,%sourceObject,%position,%damage,%damageType,%damageLoc)
	{
		%target = %sourceObject.sourceObject;
		if(%sourceObject.getClassName() $= "player" || %sourceObject.getClassName() $= "AIPlayer") %target = %sourceObject;
		if(%target.getClassName() !$= "dead" && %obj.getClassName() !$= "dead" && isObject(%obj) && isObject(%target) && %obj != %target)
		{
			if(%obj.getClassName() $= "AIPlayer" && %obj.isHoleBot && isObject(%brick = %obj.spawnBrick) && getSimTime() - %obj.lastEvent_Damaged >= 33)
			{
				$InputTarget_["Self"]   = %brick;
				$InputTarget_["Bot"] = %obj;
				$InputTarget_["Player"] = %target;
				$InputTarget_["Client"] = %client = %target.client;
				$InputTarget_["MiniGame"] = getMiniGameFromObject(%brick);
				%brick.processInputEvent("onBotDamaged", %client);
				%obj.lastEvent_Damaged = getSimTime(); //Prevent duplicates of the event (example: calling explosions within less than 33ms, which is fucking crazy)
			}
			else if(%target.getClassName() $= "AIPlayer" && %target.isHoleBot && isObject(%brick = %target.spawnBrick) && getSimTime() - %target.lastEvent_Damage >= 33)
			{
				$InputTarget_["Self"]   = %brick;
				$InputTarget_["Bot"] = %target;
				$InputTarget_["Player"] = %obj;
				$InputTarget_["Client"] = %obj.client;
				$InputTarget_["MiniGame"] = %client = getMiniGameFromObject(%brick);
				%brick.processInputEvent("onBotDamage", %client);
				%target.lastEvent_Damage = getSimTime(); //Prevent duplicates of the event (example: calling explosions within less than 33ms, which is fucking crazy)
			}
		}
		return Parent::damage(%this,%obj,%sourceObject,%position,%damage,%damageType,%damageLoc);
	}
};
activatePackage(Event_onBotDamageStuffs);
registerInputEvent("fxDTSBrick", "onBotDamage", "Self fxDTSBrick" TAB "Bot Bot" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick", "onBotDamaged", "Self fxDTSBrick" TAB "Bot Bot" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
