%error = ForceRequiredAddOn( "Support_Doors" );

if( %error == $Error::AddOn_NotFound )
{
	error("Brick_Pizza: Support_Doors is missing somehow, what did you do?");
	return;
}

datablock fxDTSBrickData(brickWholePizzaData)
{
	brickFile = "./wholePizza.blb";
	category = "Special";
	subCategory = "Food";
	uiName = "Whole Pizza";
	iconName = "Add-Ons/Brick_Pizza/wholePizza";
};

datablock fxDTSBrickData(brickPizzaBoxOpenWideData)
{
	brickFile = "./pizzaBoxOpenWide.blb";
	category = "Special";
	subCategory = "Food";
	uiName = "Pizza Boxed Wide";
	iconName = "Add-Ons/Brick_Pizza/pizzaBoxOpenWide";
	
	isDoor = 1;
	isOpen = 1;
	
	closedCW = "brickPizzaBoxClosedData";
	openCW = "brickPizzaBoxOpenData";
	
	closedCCW = "brickPizzaBoxClosedData";
	openCCW = "brickPizzaBoxOpenWideData";
};

datablock fxDTSBrickData(brickPizzaBoxOpenData : brickPizzaBoxOpenWideData)
{
	brickFile = "./pizzaBoxOpen.blb";
	uiName = "Pizza Boxed";
	iconName = "Add-Ons/Brick_Pizza/pizzaBoxOpen";
};

datablock fxDTSBrickData(brickPizzaBoxClosedData : brickPizzaBoxOpenWideData)
{
	brickFile = "./pizzaBoxClosed.blb";
	uiName = "Pizza Box";
	iconName = "Add-Ons/Brick_Pizza/pizzaBoxClosed";
	isOpen = 0;
};